var canvas = document.getElementById("myCanvas"),
    context = canvas.getContext("2d"),
    radiusRange = document.getElementById("radiusRange"),
    animateButton = document.getElementById("animateButton"),
    speed0 = document.getElementById("speed0"),
    R=Number(radiusRange.value),
    v0=Number(speed0.value),
        circle = {
        x: 250,
        y: 250,
        radius: R,
        },
        tangency = {
            x:250+R,
            y:250
        },
        info = {
        startTime: 0
        },
        ball = {
        	x:250+R+1,
        	y:250,
        	radius:1
        },
        paused = true;

var backCanvas = document.createElement('canvas'),
    backCtx = backCanvas.getContext('2d');
    backCanvas.width = canvas.width;
    backCanvas.height = canvas.height;

function drawball(){
	 context.save();

     context.beginPath();
     context.arc(circle.x, circle.y, R, 0, 2*Math.PI);
     context.lineWidth = 1;
     context.strokeStyle = "black";
     context.stroke();

     context.beginPath();
     context.arc(ball.x, ball.y, ball.radius, 0, 2*Math.PI);
     context.lineWidth = 1;
     context.strokeStyle = "black";
     context.fill();
     context.stroke();

     context.beginPath();
     context.moveTo(tangency.x, tangency.y);
     context.lineTo(ball.x, ball.y);
     context.lineWidth = 0.05;
     context.strokeStyle = "blue";
     context.stroke();


	 context.restore();
}
function draw(currentTime) {
    requestAnimFrame(draw);

    if (!paused) {
        var angle;

        if (info.startTime == 0) {
            info.startTime = currentTime;
        }

        angle = Math.sqrt(2*v0*(currentTime-info.startTime)*0.01/R); 
        tangency.x=R*Math.cos(angle)+250
        tangency.y=R*Math.sin(angle)+250
        ball.x = R*Math.cos(angle) + Math.sqrt(2*v0*R*(currentTime-info.startTime)*0.01) * Math.sin(angle)+250;
        ball.y = R*Math.sin(angle) - Math.sqrt(2*v0*R*(currentTime-info.startTime)*0.01) * Math.cos(angle)+250;
    }

    backCtx.drawImage(canvas, 0, 0, canvas.width, canvas.height);
    context.clearRect(0, 0, canvas.width, canvas.height);
    drawball();
    context.drawImage(backCanvas, 0, 0, canvas.width,canvas.height);

}

radiusRange.onchange = function(e) {
    R = Number(radiusRange.value);
            context.clearRect(0, 0, canvas.width, canvas.height);
        backCtx.clearRect(0, 0, canvas.width, canvas.height);
}
speed0.onchange = function(e){
    v0 = Number(speed0.value);
}

animateButton.onclick = function(e) {
    if (paused) {
        paused = false;
        animateButton.value = "停止";
        info.startTime = 0;
        context.clearRect(0, 0, canvas.width, canvas.height);
        backCtx.clearRect(0, 0, canvas.width, canvas.height);
    }
    else {
        paused = true;
        animateButton.value = "开始";
        tangency.x=500+R
        tangency.y=500
        ball.x=500+R+5
        ball.y=500
        context.clearRect(0, 0, canvas.width, canvas.height);
        backCtx.clearRect(0, 0, canvas.width, canvas.height);
    }
}

draw();
